<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: Thread::Crypto::HmacSha256 Class Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="../../annotated.html"><span>Classes</span></a></li>
      <li><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="../../classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="../../inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="../../functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d3/d9d/classThread_1_1Crypto_1_1HmacSha256.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="../../d9/d02/classThread_1_1Crypto_1_1HmacSha256-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Thread::Crypto::HmacSha256 Class Reference<div class="ingroups"><a class="el" href="../../d0/de1/group__core.html">Core</a> &raquo; <a class="el" href="../../dd/dcf/group__core-security.html">Security</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>This class implements HMAC SHA-256 computation.  
 <a href="../../d3/d9d/classThread_1_1Crypto_1_1HmacSha256.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="../../df/dbf/hmac__sha256_8hpp_source.html">src/core/crypto/hmac_sha256.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a98af86c21428dc8ebee7b8948736c5ba"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom">{ <a class="el" href="../../d3/d9d/classThread_1_1Crypto_1_1HmacSha256.html#a98af86c21428dc8ebee7b8948736c5baa5513e8be97ba29d99b66a23a69292a94">kHashSize</a> = 32
 }</td></tr>
<tr class="separator:a98af86c21428dc8ebee7b8948736c5ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a824d26c3a11cbedca5b22d5434fe6a19"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d9d/classThread_1_1Crypto_1_1HmacSha256.html#a824d26c3a11cbedca5b22d5434fe6a19">Start</a> (const uint8_t *aKey, uint16_t aKeyLength)</td></tr>
<tr class="memdesc:a824d26c3a11cbedca5b22d5434fe6a19"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method sets the key.  <a href="#a824d26c3a11cbedca5b22d5434fe6a19">More...</a><br /></td></tr>
<tr class="separator:a824d26c3a11cbedca5b22d5434fe6a19"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8614e60729d4ec8229cee9a5aca94abf"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d9d/classThread_1_1Crypto_1_1HmacSha256.html#a8614e60729d4ec8229cee9a5aca94abf">Update</a> (const uint8_t *aBuf, uint16_t aBufLength)</td></tr>
<tr class="memdesc:a8614e60729d4ec8229cee9a5aca94abf"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method inputs bytes into the HMAC computation.  <a href="#a8614e60729d4ec8229cee9a5aca94abf">More...</a><br /></td></tr>
<tr class="separator:a8614e60729d4ec8229cee9a5aca94abf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5c0d6c9f07e68d5deb88ea6d21193025"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d9d/classThread_1_1Crypto_1_1HmacSha256.html#a5c0d6c9f07e68d5deb88ea6d21193025">Finish</a> (uint8_t aHash[<a class="el" href="../../d3/d9d/classThread_1_1Crypto_1_1HmacSha256.html#a98af86c21428dc8ebee7b8948736c5baa5513e8be97ba29d99b66a23a69292a94">kHashSize</a>])</td></tr>
<tr class="memdesc:a5c0d6c9f07e68d5deb88ea6d21193025"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method finalizes the hash computation.  <a href="#a5c0d6c9f07e68d5deb88ea6d21193025">More...</a><br /></td></tr>
<tr class="separator:a5c0d6c9f07e68d5deb88ea6d21193025"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This class implements HMAC SHA-256 computation. </p>
</div><h2 class="groupheader">Member Enumeration Documentation</h2>
<a class="anchor" id="a98af86c21428dc8ebee7b8948736c5ba"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">anonymous enum</td>
        </tr>
      </table>
</div><div class="memdoc">
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a class="anchor" id="a98af86c21428dc8ebee7b8948736c5baa5513e8be97ba29d99b66a23a69292a94"></a>kHashSize&#160;</td><td class="fielddoc">
<p>SHA-256 hash size (bytes) </p>
</td></tr>
</table>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a5c0d6c9f07e68d5deb88ea6d21193025"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Thread::Crypto::HmacSha256::Finish </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>aHash</em>[kHashSize]</td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method finalizes the hash computation. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">aHash</td><td>A pointer to the output buffer. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d3/d9d/classThread_1_1Crypto_1_1HmacSha256_a5c0d6c9f07e68d5deb88ea6d21193025_icgraph.png" border="0" usemap="#d3/d9d/classThread_1_1Crypto_1_1HmacSha256_a5c0d6c9f07e68d5deb88ea6d21193025_icgraph" alt=""/></div>
<map name="d3/d9d/classThread_1_1Crypto_1_1HmacSha256_a5c0d6c9f07e68d5deb88ea6d21193025_icgraph" id="d3/d9d/classThread_1_1Crypto_1_1HmacSha256_a5c0d6c9f07e68d5deb88ea6d21193025_icgraph">
<area shape="rect" id="node2" href="../../d6/d44/classThread_1_1KeyManager.html#ae6b063f932c8c721eab936a9de1e4eb1" title="This method sets the Thread Master Key. " alt="" coords="252,61,398,100"/>
<area shape="rect" id="node3" href="../../d4/db5/classThread_1_1MeshCoP_1_1Joiner.html#a5109c8ea0e2c168c18f729d767e6b999" title="This method stops the Joiner service. " alt="" coords="446,5,620,44"/>
<area shape="rect" id="node4" href="../../df/d4f/group__config-general.html#gaa35a756e34a0a5427a520d5a7a91c4b5" title="Set the thrMasterKey. " alt="" coords="475,68,591,93"/>
<area shape="rect" id="node8" href="../../d3/d8e/classThread_1_1ThreadNetif.html#aa4ba0e5675b8358f6b5625e5f576daa9" title="This constructor initializes the Thread network interface. " alt="" coords="463,117,603,156"/>
<area shape="rect" id="node5" href="../../d5/dc2/structThread_1_1Cli_1_1Interpreter.html#a11ee1f86cffe17aab7de3de0bb16dee7" title="This method parses an ASCII string as an unsigned long. " alt="" coords="686,31,841,69"/>
<area shape="rect" id="node6" href="../../d9/dc8/classThread_1_1NcpBase.html#ad14f0f1d60c77f7f537a0a441a9fb35c" title="This method is called by the framer whenever a framing error is detected. " alt="" coords="668,93,859,132"/>
<area shape="rect" id="node7" href="../../dc/d60/classThread_1_1NcpUart.html#a34e4ca7aff5b9056593e8ce0aa6e2fbb" title="This method is called when uart received a data buffer. " alt="" coords="907,93,1102,132"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a824d26c3a11cbedca5b22d5434fe6a19"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Thread::Crypto::HmacSha256::Start </td>
          <td>(</td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>aKey</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aKeyLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method sets the key. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aKey</td><td>A pointer to the key. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aKeyLength</td><td>The key length in bytes. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d3/d9d/classThread_1_1Crypto_1_1HmacSha256_a824d26c3a11cbedca5b22d5434fe6a19_icgraph.png" border="0" usemap="#d3/d9d/classThread_1_1Crypto_1_1HmacSha256_a824d26c3a11cbedca5b22d5434fe6a19_icgraph" alt=""/></div>
<map name="d3/d9d/classThread_1_1Crypto_1_1HmacSha256_a824d26c3a11cbedca5b22d5434fe6a19_icgraph" id="d3/d9d/classThread_1_1Crypto_1_1HmacSha256_a824d26c3a11cbedca5b22d5434fe6a19_icgraph">
<area shape="rect" id="node2" href="../../d6/d44/classThread_1_1KeyManager.html#ae6b063f932c8c721eab936a9de1e4eb1" title="This method sets the Thread Master Key. " alt="" coords="252,61,398,100"/>
<area shape="rect" id="node3" href="../../d4/db5/classThread_1_1MeshCoP_1_1Joiner.html#a5109c8ea0e2c168c18f729d767e6b999" title="This method stops the Joiner service. " alt="" coords="446,5,620,44"/>
<area shape="rect" id="node4" href="../../df/d4f/group__config-general.html#gaa35a756e34a0a5427a520d5a7a91c4b5" title="Set the thrMasterKey. " alt="" coords="475,68,591,93"/>
<area shape="rect" id="node8" href="../../d3/d8e/classThread_1_1ThreadNetif.html#aa4ba0e5675b8358f6b5625e5f576daa9" title="This constructor initializes the Thread network interface. " alt="" coords="463,117,603,156"/>
<area shape="rect" id="node5" href="../../d5/dc2/structThread_1_1Cli_1_1Interpreter.html#a11ee1f86cffe17aab7de3de0bb16dee7" title="This method parses an ASCII string as an unsigned long. " alt="" coords="686,31,841,69"/>
<area shape="rect" id="node6" href="../../d9/dc8/classThread_1_1NcpBase.html#ad14f0f1d60c77f7f537a0a441a9fb35c" title="This method is called by the framer whenever a framing error is detected. " alt="" coords="668,93,859,132"/>
<area shape="rect" id="node7" href="../../dc/d60/classThread_1_1NcpUart.html#a34e4ca7aff5b9056593e8ce0aa6e2fbb" title="This method is called when uart received a data buffer. " alt="" coords="907,93,1102,132"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a8614e60729d4ec8229cee9a5aca94abf"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Thread::Crypto::HmacSha256::Update </td>
          <td>(</td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>aBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aBufLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method inputs bytes into the HMAC computation. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aBuf</td><td>A pointer to the input buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aBufLength</td><td>The length of <code>aBuf</code> in bytes. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d3/d9d/classThread_1_1Crypto_1_1HmacSha256_a8614e60729d4ec8229cee9a5aca94abf_icgraph.png" border="0" usemap="#d3/d9d/classThread_1_1Crypto_1_1HmacSha256_a8614e60729d4ec8229cee9a5aca94abf_icgraph" alt=""/></div>
<map name="d3/d9d/classThread_1_1Crypto_1_1HmacSha256_a8614e60729d4ec8229cee9a5aca94abf_icgraph" id="d3/d9d/classThread_1_1Crypto_1_1HmacSha256_a8614e60729d4ec8229cee9a5aca94abf_icgraph">
<area shape="rect" id="node2" href="../../d6/d44/classThread_1_1KeyManager.html#ae6b063f932c8c721eab936a9de1e4eb1" title="This method sets the Thread Master Key. " alt="" coords="252,61,398,100"/>
<area shape="rect" id="node3" href="../../d4/db5/classThread_1_1MeshCoP_1_1Joiner.html#a5109c8ea0e2c168c18f729d767e6b999" title="This method stops the Joiner service. " alt="" coords="446,5,620,44"/>
<area shape="rect" id="node4" href="../../df/d4f/group__config-general.html#gaa35a756e34a0a5427a520d5a7a91c4b5" title="Set the thrMasterKey. " alt="" coords="475,68,591,93"/>
<area shape="rect" id="node8" href="../../d3/d8e/classThread_1_1ThreadNetif.html#aa4ba0e5675b8358f6b5625e5f576daa9" title="This constructor initializes the Thread network interface. " alt="" coords="463,117,603,156"/>
<area shape="rect" id="node5" href="../../d5/dc2/structThread_1_1Cli_1_1Interpreter.html#a11ee1f86cffe17aab7de3de0bb16dee7" title="This method parses an ASCII string as an unsigned long. " alt="" coords="686,31,841,69"/>
<area shape="rect" id="node6" href="../../d9/dc8/classThread_1_1NcpBase.html#ad14f0f1d60c77f7f537a0a441a9fb35c" title="This method is called by the framer whenever a framing error is detected. " alt="" coords="668,93,859,132"/>
<area shape="rect" id="node7" href="../../dc/d60/classThread_1_1NcpUart.html#a34e4ca7aff5b9056593e8ce0aa6e2fbb" title="This method is called when uart received a data buffer. " alt="" coords="907,93,1102,132"/>
</map>
</div>
</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/core/crypto/<a class="el" href="../../df/dbf/hmac__sha256_8hpp_source.html">hmac_sha256.hpp</a></li>
<li>src/core/crypto/<a class="el" href="../../df/de1/hmac__sha256_8cpp.html">hmac_sha256.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><b>Thread</b></li><li class="navelem"><b>Crypto</b></li><li class="navelem"><a class="el" href="../../d3/d9d/classThread_1_1Crypto_1_1HmacSha256.html">HmacSha256</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:36 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
